#include "controles.h"

controles::controles(stage *fase_old,Networkh *net) {
register unsigned int i,j;
	
#if NETWORK
	updateTime=0;
	updateDelay=30;
	animation=0;
#endif

	this->net=net;
	keyPressed=new bool[322];
	for (j=0;j<255;j++)
	{
		keyPressed[j]=false;
	}

	nextShoot=0;

	//Inicializo el string que guardara los mensajes que escribamos
	mouse_speed_x=0.06f;
	mouse_speed_y=0.09f;
	actualTalkMessageArrayPos=0;
	talkMessage=0;

	fase=fase_old;
	speed=0.0008f;
	turn_speed=0.05f;
	GL3f _posCam, objCam;

	char *ntecles[KEYS]={ "TURN_L","TURN_R","WALK_F","WALK_B","STRAFE_L","STRAFE_R",
						"CENTER_V","FIRE","JUMP","CHWEAP","TALK","PAUSE" };
	
	for(int i=0;i<KEYS;i++) strcpy(tecles[i].nom,ntecles[i]);

	numLegsState=9;
	legsState=new bool[numLegsState];
	for( i=0; i<numLegsState;i++) legsState[i]=false;

	weaponStyle=FACE2FACE;
	
	pi = 3.141592653589793238462643383279;
	yaw = 0.0f;
	
	yawV=0.0f;
	
	_posCam.x=0;
	_posCam.y=0.02f;
	_posCam.z=0;

	objCam.x=_posCam.x+50.0f;
	objCam.y=_posCam.y;
	objCam.z=_posCam.z;

	fase->setCamaraPos(_posCam);
	fase->setCamaraObj(yaw,yawV);

	xc=0;
	yc=0;
 
	k=0;
	str=new char[15];
	if (!carregaFitxer()){
		printf("Error loading keys\n");
		killProgram(0);
	}
};

controles::~controles()
{
	delete[] keyPressed;
	//delete[] ntecles;
	if (talkMessage) delete []talkMessage;
	printf("CONTROLES DESTROYED\n");
};

void controles::teclat()
{
	Uint8 *keys;
	int x, y;
	bool moving=false;

	SDL_PumpEvents();
	SDL_GetRelativeMouseState(&x, &y);
	if (x||y) {
		mouseMov(x,y);
		SDL_WarpMouse(WIDTH/2,HEIGHT/2);
		//Para que no detecte el nuevo movimiento
		SDL_PumpEvents();
		SDL_GetRelativeMouseState(&x, &y);
	}

	keys = SDL_GetKeyState(NULL);

	if ( keys[SDLK_ESCAPE] )
	{
		killProgram(1);
	}

	if(!fase->getMessageControl()->isTalkMessageActive()){
		if (keys[SDLK_w]) {
			moving=true;
			legsState[WALKING_FORWARD]=true;
			walk((float)renderDelay);
		}
		else legsState[WALKING_FORWARD]=false;
		if (keys[SDLK_s]){
			moving=true;
			legsState[WALKING_BACKWARD]=true;
			walk(-(float)renderDelay);
		}
		else legsState[WALKING_BACKWARD]=false;
		if (keys[SDLK_a]) {
			moving=true;
			turn (-(float)renderDelay);
			}
		if (keys[SDLK_d]) {
			moving=true;
			turn ((float)renderDelay);
		
		}
		if (keys[SDLK_f]) {
			fire();
		}
		else setAnimation(NOT_SHOOTING,1);
				
		if (keys[SDLK_q]){
			legsState[STRAFING_LEFT]=true;
			moving=true;
			strafe(-5);
		}
		else legsState[STRAFING_LEFT]=false;
		if (keys[SDLK_e]){
			legsState[STRAFING_RIGHT]=true;
			moving=true;
			strafe (5);
		}
		legsState[STRAFING_RIGHT]=false;
		if (keys[SDLK_c]) center_v();
		if (keys[SDLK_v]) {
			if (!keyPressed[SDLK_v]){
				net->cli_sendWeap(-1);
				keyPressed[SDLK_v]=true;
			}
		}
		else keyPressed[SDLK_v]=false;
		if (keys[SDLK_i]) {
			if (!keyPressed[SDLK_i]){
				(fase->getItem(0)->isVisible())?fase->getItem(0)->setExplosion(true):fase->getItem(0)->setExplosion(false);
				keyPressed[SDLK_i]=true;
			}
		}
		else keyPressed[SDLK_i]=false;
		if (keys[SDLK_k]) {
			if (!keyPressed[SDLK_k]){
				(fase->getEnemy(0)->isDying())?fase->getEnemy(0)->reviveEnemy():fase->getEnemy(0)->killEnemy();
				keyPressed[SDLK_k]=true;
			}
		}
		else keyPressed[SDLK_k]=false;
		if (keys[SDLK_3]) {

#if !NETWORK
			GL3f _posCam=fase->getCamaraPos();
#endif
			yawV=yawV+(pi/90.0)*turn_speed;
						
			fase->setCamaraObj(yaw,yawV);
		}
		if (keys[SDLK_4]) {

#if !NETWORK
			GL3f _posCam=fase->getCamaraPos();
#endif
			yawV=yawV-(pi/90.0)*turn_speed;
		
			fase->setCamaraObj(yaw,yawV);
		}
		if (keys[SDLK_t]) {
			if (!talkMessage) talkMessage=new char[MAX_MESSAGE_LENGTH];
			talkMessage[0]=0;
			fase->getMessageControl()->createTalkMessage(talkMessage);
			keyPressed[SDLK_t]=true;
		}
		if (keys[SDLK_F1]) {
			if (!keyPressed[SDLK_F1]){
				if (!PORTALES) fase->getMessageControl()->addMessage("Portal mode on");
				else fase->getMessageControl()->addMessage("Portal mode off");
				PORTALES?PORTALES=false:PORTALES=true;
				keyPressed[SDLK_F1]=true;
			}
		}
		else keyPressed[SDLK_F1]=false;
			
		if (keys[SDLK_F2]) {
			if (!keyPressed[SDLK_F2]){

				if (!BOUNDING) fase->getMessageControl()->addMessage("Bounding mode on");
				else fase->getMessageControl()->addMessage("Bounding mode off");

				BOUNDING?BOUNDING=false:BOUNDING=true;
				keyPressed[SDLK_F2]=true;
			}
		}
		else keyPressed[SDLK_F2]=false;

		if (keys[SDLK_F3]) {
			if ( !keyPressed[SDLK_F3]){

				if (!DEBUG) fase->getMessageControl()->addMessage("Painting triangles");
				else if (DEBUG==1) fase->getMessageControl()->addMessage("Painting a lot :P");
				else fase->getMessageControl()->addMessage("Painting normal");

				if (DEBUG<2)DEBUG++;
				else DEBUG=0;
				keyPressed[SDLK_F3]=true;
			}
		}
		else keyPressed[SDLK_F3]=false;

		if (keys[SDLK_F4]) {
			if (!keyPressed[SDLK_F4]){
				
				if (!TEXTURA) fase->getMessageControl()->addMessage("Painting Textures");
				else fase->getMessageControl()->addMessage("Tripi mode on :)");

				TEXTURA?TEXTURA=false:TEXTURA=true;
				keyPressed[SDLK_F4]=true;
			}
		}
		else keyPressed[SDLK_F4]=false;
		if (keys[SDLK_F5]) {
			if (!keyPressed[SDLK_F5]){
				saveScreenShot();				
				keyPressed[SDLK_F5]=true;
			}
		}
		else keyPressed[SDLK_F5]=false;
	}
	else {
		if(keys[SDLK_RETURN]){
			printf("Message send: %s\n",talkMessage);
			net->cli_sendTalk(talkMessage);
			fase->getMessageControl()->destroyTalkMessage();
			delete[] talkMessage;
			talkMessage=0;
			actualTalkMessageArrayPos=0;
		}
		else{
			char *c=new char[10];
			for(int i=0;i<45;i++){
				fase->getMessageControl()->translate(i,c);
				for (int j=0;c[j]!=0;j++){
					if (keys[c[j]]) {
						if (!keyPressed[c[j]]) createString(c[j]);
						keyPressed[c[j]]=true;
					}
					else keyPressed[c[j]]=false;
				}
				
			}
			if (keys[SDLK_SPACE]) {
				if (!keyPressed[SDLK_SPACE]) createString(' ');
				keyPressed[SDLK_SPACE]=true;
			}
			else keyPressed[SDLK_SPACE]=false;

			if (keys[SDLK_BACKSPACE]) {
				if (!keyPressed[SDLK_BACKSPACE]) createString(SDLK_BACKSPACE);
				keyPressed[SDLK_BACKSPACE]=true;
			}
			else keyPressed[SDLK_BACKSPACE]=false;
			
			delete[] c;
			
		}
	}

	if (!moving) {
		setAnimation(NOT_MOVING,2);
		legsState[NOT_MOVING]=true;
	}
	else legsState[NOT_MOVING]=false;
	testKeys(keys);
}


void controles::turn(float dir) {
#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();

	
#endif

	if (yaw>=2*pi) yaw-=2*pi;
	if (yaw<=0) yaw+=2*pi;
	yaw=yaw+dir*(pi/90.0)*turn_speed;

	fase->setCamaraObj(yaw,yawV);

	}

void controles::walk(float dir) {
#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();
#else
	
	if (dir>0) setAnimation(RUNNING_FORWARD,2);
	else setAnimation(RUNNING_BACKWARD,2);

#endif
	_posCam.x+=(dir*((float)cos(yaw)))*speed;
	_posCam.z+=(dir*((float)sin(yaw)))*speed;

	fase->setCamaraObj(yaw,yawV);
#if !NETWORK
	fase->setCamaraPos(_posCam);
#endif
	
	}

void controles::strafe(float dir) {
#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();
#else

	if (dir>0) setAnimation(STRAFING_RIGHT,2);
	else setAnimation(STRAFING_LEFT,2);


#endif
	_posCam.x+=(float)cos(yaw+(pi/2))*speed*dir;
	_posCam.z+=(float)sin(yaw+(pi/2))*speed*dir;

	fase->setCamaraObj(yaw,yawV);
#if !NETWORK
	fase->setCamaraPos(_posCam);
#endif

	}

void controles::center_v() {

#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();
#endif
	yawV=0.0f;

	fase->setCamaraObj(yaw,yawV);
	}

void controles::fire() {
	if (SDL_GetTicks()<nextShoot) return;
	
	nextShoot=SDL_GetTicks()+fase->getCamaraWeapon()->getDelay();
	setAnimation(SHOOTING,1);
	GL3f pos(fase->getCamaraPos().x,fase->getCamaraPos().y+PLAYER_HEIGHT,fase->getCamaraPos().z);
	GL3f vec((float)cos(yaw)*(float)cos(yawV),(float)sin(yawV),(float)sin(yaw)*(float)cos(yawV));
	printf("SHOOTING\n");
	net->cli_sendShot(pos.x,pos.y,pos.z,vec.x,vec.y,vec.z);
	}

void controles::jump() {
	fase->getMessageControl()->addMessage("Jumping to the moon!!!");
	}

void controles::chweap() {
	fase->getMessageControl()->addMessage("Weapon Changed!!!");

	}

void controles::talk() {
	talkMessage[0]=0;
	actualTalkMessageArrayPos=0;
	fase->getMessageControl()->createTalkMessage(talkMessage);
	}

void controles::pause() {
	printf("game paused\n");
	}


int controles::carregaFitxer() {
	int i;

	file = fopen(ruta, "r");
	if (!file) return 0;
	while(!feof(file)) {
		fscanf(file,"%s",str);
		for(i=0;i<KEYS;i++) {
			if(!strcmp(str,tecles[i].nom)) {
				fscanf(file,"%s",str);
				if(!strcmp(str,"SPACE")) strcpy(tecles[i].tecl,(char *)" ");
				else strcpy(tecles[i].tecl,str);
				}
			}
		}
	
	return 1;
	}

void controles::Keys(int i) {
	switch(i)
		{
		case TURN_L:	turn(-1);	break;
		case TURN_R:	turn(1);	break;
		case WALK_F:	walk(1);	break;
		case WALK_B:	walk(-1);	break;
		case STRAFE_L:	strafe(-1); break;
		case STRAFE_R:	strafe(1);	break;
		case CENTER_V:	center_v(); break;
		case FIRE:		fire();		break;
		case JUMP:		jump();		break;
		case CHWEAP:	chweap();	break;
		case TALK:		talk();		break;
		case PAUSE:		pause();	break;
		}
}

void controles::testKey(char key)
{
	int i;
	
	for(i=0;i<KEYS;i++)
	{
		if (tecles[i].tecl[1]!=0) continue;
		if (key==tecles[i].tecl[0])
		{
			Keys(i);
			return;
		}
	}
}

void controles::testKey(char *key)
{ 
	int i;
	for(i=0;i<KEYS;i++)
	{
		if (!strcmp(key,tecles[i].tecl))
		{
			Keys(i);
			return;
		}
	}
}


void controles::testKeys(Uint8 *k)
{
//	printf("mola\n");
	if (k[SDLK_1])
	{
#if !NETWORK
		GL3f _posCam=fase->getCamaraPos();
#endif

		_posCam.y+=speed*renderDelay;

#if !NETWORK
		fase->setCamaraPos(_posCam);
#endif

	}else
	if (k[SDLK_2])
	{
#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();
#endif

			_posCam.y-=speed*renderDelay;

#if !NETWORK
		fase->setCamaraPos(_posCam);
#endif

	}
}

void controles::teclat(unsigned char key) {
	GL3f posCam=fase->getCamaraPos();

	char a[2];
	if(!fase->getMessageControl()->isTalkMessageActive())
	{
		if (key>='a') key-='a'-'A';
		a[0]=key; a[1]=0;
		printf("KEYPAWAH :%c\n",key);
		testKey(key);

		switch(key)
		{
		case 'A':
			posCam.y+=speed;
			fase->setCamaraPos(posCam);
			break;
		case 'Z':
			posCam.y-=speed;
			fase->setCamaraPos(posCam);
			break;
		case 'E':
			walk(1);
			break;
		case 'D':
			walk(-1);
			break;
		case 'S':
			turn(-1);
			break;
		case 'F':
			turn(1);
			break;
		case 'Q'||27:
			killProgram(0);
			break;
		case '*':
			if (DEBUG)
			{
			fase->getMessageControl()->addMessage("Debug off");
				DEBUG=false;
			} else {
				DEBUG=true;
			fase->getMessageControl()->addMessage("Debug on");
			}
			break;
		}
	} else {
		if(key==13)
		{
			char temp[300];
			sprintf(temp,"DAVID: %s",talkMessage);
			fase->getMessageControl()->addMessage(temp);
			fase->getMessageControl()->destroyTalkMessage();
		} else {
			createString((char)key);
		}
	}
}


void controles::mouseMov(int x, int y) 
{
	float MAX_FACTOR=0.9999f;

#if !NETWORK
	GL3f _posCam=fase->getCamaraPos();
#endif
	//if (y>yc && objCam.y<70.0f) objCam.y-=1;
	//if (y<yc && objCam.y>-70.0f) objCam.y+=1;

	if (yaw>=2*pi) yaw-=2*pi;
	if (yaw<=0) yaw+=2*pi;
	yaw+=x*(pi/90.0)*mouse_speed_x;
	yawV-=y*(pi/90.0)*mouse_speed_y;

	if (yawV>=(pi/2)*MAX_FACTOR) yawV=(pi/2)*MAX_FACTOR;
	else if (yawV<=-(pi/2)*MAX_FACTOR) yawV=-(pi/2)*MAX_FACTOR;

	fase->setCamaraObj(yaw,yawV);

			
}

/*
void controles::rotaCamara(float angulo,float x,float y,float z){
	GL3f vistaNueva;

	//Cojemos la direccin en la que miramos;
	GL3f posCam=fase->getCamaraPos();
	GL3f objCam=fase->getCamaraObj();
	GL3f objCamView=objCam-posCam;
	
	float cosAngle=(float)cos(angulo);
	float sinAngle=(float)sin(angulo);

	vistaNueva.x=(cosAngle + (1 - cosAngle) * x * x) * objCamView.x;
	vistaNueva.x+=((1 - cosAngle) * x * y - z * sinAngle) * objCamView.y;
	vistaNueva.x+=((1 - cosAngle) * x * z + y * sinAngle) * objCamView.z;

	vistaNueva.y=((1 - cosAngle) * x * y + sinAngle) * objCamView.x;
	vistaNueva.y+=(cosAngle + (1 - cosAngle) * y * y) * objCamView.y;
	vistaNueva.y+=((1 - cosAngle) * y * z - x * sinAngle) * objCamView.z;

	vistaNueva.z=((1 - cosAngle) * x * z -y * sinAngle) * objCamView.x;
	vistaNueva.z+=((1 - cosAngle) * y * z + x * sinAngle) * objCamView.y;
	vistaNueva.z+=(cosAngle + (1 - cosAngle) * z * z) * objCamView.z;

	objCam=vistaNueva + posCam;

	fase->setCamaraPos(posCam);
	fase->setCamaraObj(objCam);
}
*/
void controles::createString(char letra){
	if (letra==8) 
	{
		if(actualTalkMessageArrayPos>0) actualTalkMessageArrayPos--;
	} else {
		talkMessage[actualTalkMessageArrayPos]=letra;
		actualTalkMessageArrayPos++;
	}
	talkMessage[actualTalkMessageArrayPos]=0;
}

#if NETWORK
void controles::updateNet(){
	if (SDL_GetTicks()>=updateTime){
		updateTime=SDL_GetTicks()+updateDelay;
		net->cli_sendMove(_posCam,(int)((yaw*180.0f/PI)),animation);
	}
}
#endif

void controles::saveScreenShot(){
//	SDL_UnlockSurface(WINDOW);
//	SDL_SaveBMP(WINDOW,"mola.bmp");
	fase->getMessageControl()->addMessage("Screenshot saved");
}

void controles::setAnimation(int which,int part){
	int ani1=(animation&3),
		ani2=((animation&28)>>2),
		ani3=((animation&224)>>5);
	if (part==1){
		if (which==SHOOTING){
			switch(weaponStyle){
			case FACE2FACE:
				ani2=SHOOTING_FACE2FACE;
				break;
			case _1HAND:
				ani2=SHOOTING_1HAND;
				break;
			case _2HAND:
				ani2=SHOOTING_2HAND;
				break;
			}
		}
		else if (which==NOT_SHOOTING){
			switch(weaponStyle){
			case FACE2FACE:
				ani2=NOT_SHOOTING_FACE2FACE;
				break;
			case _1HAND:
				ani2=NOT_SHOOTING_1HAND;
				break;
			case _2HAND:
				ani2=NOT_SHOOTING_2HAND;
				break;
			}
		}
		
	}
	if (part==2){
		if (which==RUNNING_FORWARD || which==RUNNING_BACKWARD || which==WALKING_FORWARD || which==WALKING_BACKWARD){
			ani3=which;
			fase->getMap()->playSound(fase->getCamaraId(),RUNNING_FORWARD,fase->getCamaraPos());
		}
		else if (which==NOT_MOVING){
			ani3=NOT_MOVING;
			fase->getMap()->stopSound();
		}
		else if (!legsState[RUNNING_FORWARD] && !legsState[RUNNING_BACKWARD] && !legsState[WALKING_FORWARD] && !legsState[WALKING_BACKWARD]){
			ani3=which;
			fase->getMap()->playSound(fase->getCamaraId(),WALKING_FORWARD,fase->getCamaraPos());
		}

	}


	animation=0;
	animation+=(ani1);
	animation+=(ani2<<2);
	animation+=(ani3<<5);
}
