//Esta es la clase que guarda cada posicion de la animacion de un personaje (un frame
//de una animacin.


#ifndef _FIGURE_H_
#define _FIGURE_H_


#include <stdio.h>
#include "structures.h"



//Clase que almacena los diferentes frames de la animacion
class figure{

	float *vertex;	//Array con la posicion de cada vertice (x,y,z);
	int numFaces;   //Numero de caras
	
public:

	//Constructor de la clase al cual recibe el numero de caras que el objeto tiene
	figure(int num_faces_old);

	//Constructor de copia de la clase
	figure(figure &figure_copia);

	//Destructor
	~figure();

	//Crea una estructura de floats con la posicion de los distintos vertices 
	void addVertex(float *vertex_old);

	//Funcion que devuelve el array de vertices del objeto
	float *getVertex();


	
	
};


#endif


