//	Cosas relativas a las fuentes....

#include <string.h>
#include <stdarg.h>
#include "structures.h"
#include <GL/glu.h>
#include "TGAload.h"
#include "external.h"


#ifndef _FUENTES_STR          
#define _FUENTES_STR



class texto2D{
	

	
	unsigned int mapabits;


public:

	texto2D();
	texto2D(char *fichero);

	/*! tam_base es el tamao base para esa fuente. Cuando se
	utilice la funcin print, el tamao que se especifique ah
	ser en funcin de como se inicializ 
	espacio_base es el espacio entre letras de cada fuente,
	es bastante dependiente del tipo de fuente */

	bool carga_fuente(char *fichero);

	/*! Especificamos el tipo de fuente (previamente creado), su
	posisicin (-1,-1 a 1,1), el tamao y el texto. Se pueden 
	utilizar cadenas las cadenas de formato como printf(etc) */								
					
	void print(char *texto,float x,float y,float r,float g,float b,float size);
	void translate(int num, char* palabras);

	char *getName();
	unsigned int getMapabits()  { return mapabits; };

};					

#endif 

