#include "game.h"




game::game(){
	char loading[20];
	char nick[100],pass[100],server[100],temp[100];
	int port;
	
	glhRandomize();

	renderScreen=new render();
	sprintf(loading,"loading%d.tga",(int)(rand()%3));
	printf("%s\n",loading);
	drawImage(loading,true);

#if NETWORK

	FILE *archivo;
	system("pwd");

	archivo=fopen("config.cli","rt");
	if (!archivo) {
		printf("Couldn't find config.cli\n");
		killProgram(0);
	}
	while(!feof(archivo)){
		temp[0]=0;
		fscanf(archivo,"%s",temp);
		if (!strcmp(temp,"LOGIN")) {
			fscanf(archivo,"%s",nick);
		}
		else if (!strcmp(temp,"PASSWORD")) {
			fscanf(archivo,"%s",pass);
		}
		else if (!strcmp(temp,"SERVER")) {
			fscanf(archivo,"%s",server);
		}
		else if (!strcmp(temp,"PORT")) {
			fscanf(archivo,"%d",&port);
		}

	}
	try {
	net=new Networkh(server,nick,pass,port,10240);	
	} catch(int e) {
		printf("Unable to connect to remote host (%d)\n",e);
		killProgram(0);
	}
	//192.168.1.67

	while (!net->conected()) SDL_Delay(1000);
#endif


	fase=new stage("castle.mph");
	teclado=new controles(fase,net);

#if NETWORK	
	net->setStage(fase);
#endif

}

game::~game(){
	delete renderScreen;
	delete fase;
	delete teclado;
#if NETWORK
	delete net;
#endif

	printf("GAME DESTROYED\n");
}


void game::pintaPantalla(){
#if NETWORK	
	teclado->updateNet();
#endif
	//Actualizamos todos los elementos de la fase
	fase->update();
	//Pintamos la fase
	renderScreen->dibuja(fase);
	
}
