#include "opengl.h"

void glhTranslatef(GL3f position){
	glTranslatef(position.x,position.y,position.z);
}

void glhRotatef(GL3f rotation){
	glRotatef(rotation.x,1,0,0);
	glRotatef(rotation.y,0,1,0);
	glRotatef(rotation.z,0,0,1);
}

void glhScalef(GL3f scale){
	glScalef(scale.x,scale.y,scale.z);
}

void glhVertex3f(GL3f vertex){
	glVertex3f(vertex.x,vertex.y,vertex.z);
}

void gluhLookAt(GL3f pos, GL3f obj, float x, float y, float z){
	gluLookAt(pos.x,pos.y,pos.z,
		      obj.x,obj.y,obj.z,
			  x,y,z);
}



