#ifndef _OPENGL_H_
#define _OPENGL_H_

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include "structures.h"


void glhTranslatef(GL3f posicion);

void glhRotatef(GL3f rotation);

void glhScalef(GL3f scale);

void glhVertex3f(GL3f vertex);

void gluhLookAt(GL3f pos, GL3f obj, float x, float y, float z);

#endif
