#include "weapon.h"

weapon::weapon(char *file){

	char buf[100];
	FILE *fd;

	chdir(getDirs(file));
	fd=fopen (file,"r");
	
	if (!fd)
	{
		system("pwd");
		printf(" ###### Error loading weapon %s ######\n",file );
		killProgram(0);
	}
	chdir("../..");

	damage=0;
	delay=0;
	maxAmmo=0;
	delay=0;

	do{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp(buf,"MODEL1")){
			fscanf(fd,"%s",buf);
			model1=new control(buf);
		}
		else if (!strcmp(buf,"MODEL3")){
			fscanf(fd,"%s",buf);
			model3=new control(buf);
		}
		else if (!strcmp(buf,"DAMAGE")){
			fscanf(fd,"%d",&damage);
		}
		else if (!strcmp(buf,"DELAY")){
			fscanf(fd,"%d",&delay);
		}
		else if (!strcmp(buf,"MAXAMMO")){
			fscanf(fd,"%d",&maxAmmo);
		}
		else if (!strcmp(buf,"TYPE")){
			fscanf(fd,"%d",&type);
		}

	}while (!feof(fd));
}

int weapon::getMaxAmmo(){
	return maxAmmo;
}

int weapon::getDamage(){
	return damage;
}

int weapon::getDelay(){
	return delay;
}
control *weapon::getFirstView(){
	return model1;
}

control *weapon::getThirdView(){
	return model3;
}


weapon::weapon(const weapon &weapon_){
	model1=new control(*weapon_.model1);
	model3=new control(*weapon_.model3);
	maxAmmo=weapon_.maxAmmo;
	damage=weapon_.damage;
	delay=weapon_.delay;

}

void weapon::update(){
	model1->update();
	model3->update();
}

