#include "camara.h"


camara::camara(char *ruta)
	{
	HUD = new Interface("hud.tga", "font_big.tga", "font_small.tga");
	DNI=-1;
	yawH=0.0;
	yawV=0.0;
	carga (ruta);
	idLegs=this->getControl(LEGS)->getObject3d()->getTexture().idTex;
	idBody=this->getControl(BODY)->getObject3d()->getTexture().idTex;
	idHead=this->getControl(HEAD)->getObject3d()->getTexture().idTex;
	}

GL3f camara::getObjPos()
	{
		GL3f objCam;
		objCam.x=getPos().x+(float)cos(yawH)*(float)cos(yawV);
		objCam.y=getPos().y+(float)sin(yawV);
		objCam.z=getPos().z+(float)sin(yawH)*(float)cos(yawV);
		return objCam;
	}

void camara::setObj(double yawH, double yawV)
	{
	this->yawH=yawH;
	this->yawV=yawV;
	}

int camara::getDNI(){
	return DNI;
}

void camara::setDNI(int DNI){
	this->DNI=DNI;
}

Interface *camara::getInterface(){
	return HUD;
}

