#ifndef _CONTROLES_H_
#define _CONTROLES_H_

#if WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <SDL/SDL.h>
#include "mates.h"
#include "stage.h"
#include "external.h"
#include "Networkh.h"

extern void killProgram(int mode);
extern SDL_Surface *WINDOW;

#define ruta "config.kbd"

	
enum {	TURN_L,TURN_R,WALK_F,
		WALK_B, STRAFE_L, STRAFE_R,
		CENTER_V , FIRE, JUMP,
		CHWEAP,TALK, PAUSE,
		KEYS };

class controles {
	int animation;
#if NETWORK
	
	unsigned int updateTime,
				 updateDelay;
#endif
	stage *fase;
	Networkh *net;

	float mouse_speed_x, mouse_speed_y;
	float speed;
	float turn_speed;
	FILE *file;

	int numLegsState;
	bool *legsState;

	int weaponStyle;

	unsigned int nextShoot;

	int xc,yc;

	bool *keyPressed;

	int k;

	double pi;
	double yaw,yawV;

//	char *ntecles[KEYS]; 

	char *str;
	char *talkMessage;
	int actualTalkMessageArrayPos;
		
	struct {
		char nom[15];
		char tecl[15];
	} tecles [KEYS];


public:
	controles(stage *fase_old, Networkh *net);
	~controles();

	void turn(float dir),
		 walk(float dir),
		 strafe(float dir),
		 center_v(),
		 fire(),
		 jump(),
		 chweap(),
		 talk(),
		 pause();

	int carregaFitxer();

	void teclat(); // main kbd control.
	void teclat(unsigned char key);
	void mouseMov(int x, int y);
	void Keys(int i);
	void testKey(char key);
	void testKey(char *key);
	void testKeys(Uint8 *k);
	void rotaCamara(float angulo,float x,float y,float z);
	void createString(char letra);
	void saveScreenShot();
	void setAnimation(int which, int part);

#if NETWORK
	void updateNet();
#endif
};

#endif

