#ifndef _HELP_H_
#define _HELP_H_

#if WIN32
#include <windows.h>
#endif

#include "structures.h"
#include "external.h"
#include <GL/glu.h>
#include "string.h"
#include "SDL/SDL.h"
#include "dirs.h"


//Le pasas un bounding y te devuelve el centro de este
GL3f getBoundingPos(GLBounding bounding);

//Le pasas la "x" y la "y" y te pasa el mundo a 2d
void glEnter2D(int width, int height);

//Cierra el mundo el 2d
void glExit2D();

//Pinta un texto por pantalla, le pasas el texto, la x, la y y la fuente.
void drawString(char *messageStr, int x, int y,char* message_font);

void drawImage(char *file, bool invert=false);

void glhRandomize();

#endif

